## Script (Python) "manage_versions_sort_versions"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=get_fields='', all_versions=''
##title=Sort Versions for display purposes.
##
REQUEST = context.REQUEST
the_versions = all_versions
sort_by = REQUEST.get('sort_by', 'version_number')
sort_order = REQUEST.get('sort_order', 'asc')

def cmp_sort(x, y, sort_order):
  if sort_order == 'desc':
    return cmp(y,x)
  else:
    return cmp(x,y)

if get_fields:
  sort_by_fields = [{'sort_by'      : 'version_number',
             'display_name' : 'Tree View',
             'sort_order'   : 'asc'},
            {'sort_by'      : 'version_state',
             'display_name' : 'Status',
             'sort_order'   : 'asc'},
            {'sort_by'      : 'version_created',
             'display_name' : 'Created Date',
             'sort_order'   : 'desc'},
            {'sort_by'      : 'version_modified',
             'display_name' : 'Modified_Date',
             'sort_order'   : 'desc'},
            {'sort_by'      : 'version_owner',
             'display_name' : 'Owner',
             'sort_order'   : 'asc'}
               ];
  for field in sort_by_fields:
    field['style'] = ''
    if field['sort_by'] == sort_by:
      if sort_order == 'asc':
        field['sort_order'] = 'desc'
        field['style'] = 'text-decoration:overline;color:#3300FF;'
      else:
        field['sort_order'] = 'asc'
        field['style'] = 'text-decoration:underline;color:#3300FF;'

  return sort_by_fields

if sort_by == 'version_number':
  the_versions.sort(lambda x,y: cmp_sort(x.version_number, y.version_number, sort_order))
elif sort_by == 'version_state':
  the_versions.sort(lambda x,y: cmp_sort(context.portal_workflow.getInfoFor(x,'review_state'), context.portal_workflow.getInfoFor(y,'review_state'), sort_order))
elif sort_by == 'version_created':
  the_versions.sort(lambda x,y: cmp_sort(x.created, y.created, sort_order))
elif sort_by == 'version_modified':
  the_versions.sort(lambda x,y: cmp_sort(x.modified, y.modified, sort_order))
elif sort_by == 'version_owner':
  the_versions.sort(lambda x,y: cmp_sort(', '.join(x.users_with_local_role('Owner')), ', '.join(y.users_with_local_role('Owner')), sort_order))

return the_versions
